# Algo VPN documentation

* Deployment instructions
  - Deploy from [RedHat/CentOS 6.x](deploy-from-redhat-centos6.md)
  - Deploy from [Windows](deploy-from-windows.md)
  - Deploy from a [Docker container](deploy-from-docker.md)
  - Deploy from [Ansible](deploy-from-ansible.md) non-interactively
  - Deploy onto a [cloud server at time of creation](deploy-from-script-or-cloud-init-to-localhost.md)
* Client setup
  - Setup [Android](client-android.md) clients
  - Setup [Generic/Linux](client-linux.md) clients with Ansible
  - Setup Ubuntu clients to use [WireGuard](client-linux-wireguard.md)
  - Setup Linux clients to use [IPSEC](client-linux-ipsec.md)
  - Setup Apple devices to use [IPSEC](client-apple-ipsec.md)
  - Setup Macs running macOS 10.13 or older to use [Wireguard](client-macos-wireguard.md)
* Cloud provider setup
  - Configure [Amazon EC2](cloud-amazon-ec2.md)
  - Configure [Azure](cloud-azure.md)
  - Configure [DigitalOcean](cloud-do.md)
  - Configure [Google Cloud Platform](cloud-gce.md)
  - Configure [Vultr](cloud-vultr.md)
  - Configure [CloudStack](cloud-cloudstack.md)
  - Configure [Hetzner Cloud](cloud-hetzner.md)
* Advanced Deployment
  - Deploy to your own [FreeBSD](deploy-to-freebsd.md) server
  - Deploy to your own [Ubuntu](deploy-to-ubuntu.md) server
  - Deploy to an [unsupported cloud provider](deploy-to-unsupported-cloud.md)
* [FAQ](faq.md)
* [Firewalls](firewalls.md)
* [Troubleshooting](troubleshooting.md)
